' @copyright(disclaimer) 
' Licensed Materials - Property of IBM
' IBM  Enterprise Information Portal for Multiplatforms V8.1  (program number 5724-B43)
' (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
' 
' US Government Users Restricted Rights
' Use, duplication or disclosure restricted by GSA ADP Schedule
' Contract with IBM Corp.
' 
' DISCLAIMER OF WARRANTIES :
' 
' Permission is granted to copy and modify this Sample code, and to
' distribute modified versions provided that both the copyright
' notice,- and this permission notice and warranty disclaimer appear in all copies and 
' modified versions. 
' 
' THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
' IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, 
' IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE IMPLIED 
' WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL 
' IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF THE USE OF OR 
' INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION OF THE 
' SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS LICENSORS AND 
' SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR DIRECT, INDIRECT, 
' SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF 
' THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
' OF THE POSSIBILITY OF SUCH DAMAGES.
'
' @endCopyright

VERSION 5.00
Begin VB.Form CombinedQ 
   AutoRedraw      =   -1  'True
   Caption         =   "Combined Query"
   ClientHeight    =   6225
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5955
   LinkTopic       =   "Form1"
   ScaleHeight     =   6225
   ScaleWidth      =   5955
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox TQueryString 
      Height          =   1095
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   7
      ToolTipText     =   "Sets/Displays text query string"
      Top             =   4320
      Width           =   3735
   End
   Begin VB.CommandButton Query 
      Caption         =   "Execute"
      Height          =   375
      Left            =   4200
      TabIndex        =   6
      ToolTipText     =   "executes the query"
      Top             =   3720
      Width           =   1215
   End
   Begin VB.TextBox PQueryString 
      Height          =   1095
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   4
      ToolTipText     =   "sets/displays query parametric string"
      Top             =   2400
      Width           =   3735
   End
   Begin VB.CommandButton Disconnect 
      Caption         =   "Disconnect"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4200
      TabIndex        =   2
      ToolTipText     =   "disconnects from a datastore"
      Top             =   1320
      Width           =   1215
   End
   Begin VB.CommandButton Connect 
      Caption         =   "Connect"
      Height          =   375
      Left            =   4200
      TabIndex        =   1
      ToolTipText     =   "connects to a datastore"
      Top             =   840
      Width           =   1215
   End
   Begin VB.TextBox Status 
      BackColor       =   &H80000011&
      Height          =   615
      Left            =   240
      Locked          =   -1  'True
      TabIndex        =   0
      ToolTipText     =   "status of connect/disconnect"
      Top             =   960
      Width           =   3735
   End
   Begin VB.Label TQueryLabel 
      Caption         =   "Text Query"
      Height          =   255
      Left            =   240
      TabIndex        =   8
      Top             =   3960
      Width           =   1095
   End
   Begin VB.Label PQueryLabel 
      Caption         =   "Parametric Query"
      Height          =   255
      Left            =   240
      TabIndex        =   5
      Top             =   2040
      Width           =   1215
   End
   Begin VB.Label StatusText 
      Caption         =   "Status"
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   600
      Width           =   1215
   End
   Begin VB.Image Image1 
      Height          =   615
      Left            =   2760
      Top             =   960
      Width           =   975
   End
End
Attribute VB_Name = "CombinedQ"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Function LoadLibraryA Lib "Kernel32" (ByVal f$) As Integer
Private Declare Sub FreeLibrary Lib "Kernel32" (ByVal h As Integer)
Dim hInst As Integer

'Declare global datastore objects
Private tm As DXDatastoreTS
Private vi As DXDatastoreDL

Private Sub Connect_Click()

  'There's currently a problem with loading the DL dll
  'more than once within VB.  This doesn't occur if the
  'application is packaged as as exe and runs outside the
  'VB environment, or if VB is shut down and restarted
  'right after execution, or if the form stays up.  To
  'get around this problem during development, the
  'following statement is used to manually load/unload
  'the dll.
  hInst = LoadLibraryA("cmbxdl716.dll")

  Dim DEConnect As String
  DEConnect = "SQLDSTYPE=DB2;SQLUID=db2inst1;SQLPWD=ibmdb2;SQLLSUID=lsadmin"
   
  'Connect to DL server - replace the following with
  'your own
  Set vi = New DXDatastoreDL
  vi.Connect "LIBSRVRX", "FRNADMIN", "PASSWORD", DEConnect
  On Error GoTo HandleError
  
  'Connect to TS server - replace the following with
  'your own
  Set tm = New DXDatastoreTS
  tm.connectPort "TM", "", DX_TS_CTYP_TCPIP
  On Error GoTo HandleError
  
  'Update the status text
  Status.Text = "Connected to VI and TS"
  Disconnect.Enabled = True
  Connect.Enabled = False
  Exit Sub
  
HandleError:
  Status.Text = Str(Err.Number) & Err.Description
  
End Sub

Private Sub Disconnect_Click()

  'Disconnect from DL server
  vi.Disconnect
  On Error GoTo HandleError
  
  'Disconnect from TS server
  tm.Disconnect
  On Error GoTo HandleError
  
  'Update the status text
  Status.Text = "Disconnected from VI and TS"
  Connect.Enabled = True
  Disconnect.Enabled = False
  Exit Sub
  
HandleError:
  Status.Text = Str(Err.Number) & Err.Description
  
End Sub

Private Sub Form_Unload(Cancel As Integer)

  'Clean up resources
  Set vi = Nothing
  Set tm = Nothing

  'Remove before building an exe
  FreeLibrary (hInst)
End Sub

Private Sub Query_Click()

  'Define parametric query
  Dim myPQuery As String
  'Replace the following query string with your own -
  'or get text from Parametric Query text box - remember to
  'strip out the line feed and carriage control characters
  'myPQuery = PQueryString.Text
  myPQuery = "SEARCH=(INDEX_CLASS=DLSAMPLE,"
  myPQuery = myPQuery & "MAX_RESULTS=2,"
  myPQuery = myPQuery & "COND=(DLSEARCH_DocType <> NULL));"
  'myPQuery = myPQuery & "INDEX_CLASS=DLSAMPLE,MAX_RESULTS=5,"
  'myPQuery = myPQuery & "COND=(DLSEARCH_Date > 1995));"
  myPQuery = myPQuery & "OPTION=(CONTENT=YES;TYPE_QUERY=STATIC;TYPE_FILTER=FOLDERDOC)"
  PQueryString.Text = myPQuery
  Dim PQuery As Variant
  Dim parmEnd(1 To 1) As New DXNVPairDL
  parmEnd(1).setName DX_DL_PARM_END

  Set PQuery = vi.createQuery(myPQuery, DX_DL_PARAMETRIC_QL_TYPE, parmEnd)
  
  'Define Text query
  Dim myTQuery As String
  'Replace the following query string with your own -
  'Or get text from Text Query text box - remember to
  'strip out the line feed and carriage control characters
  'myTQuery = TQueryString.Text
  myTQuery = "SEARCH=(COND=(UNIX));"
  myTQuery = myTQuery & "OPTION=(SEARCH_INDEX=TMINDEX)"
  TQueryString.Text = myTQuery
  Dim TQuery As Variant
  Set TQuery = tm.createQuery(myTQuery, DX_TS_TEXT_QL_TYPE, parmEnd)
  
  'Define combined query
  Dim CQuery As New DXCombinedQueryOptDL
  'Dim parm(1 To 3) As New DXNVPairDL
  'parm(1).Set DX_DL_PARM_QUERY, PQuery
  'parm(2).Set DX_DL_TEXT_QUERY, TQuery
  'parm(3).setName DX_DL_PARM_END
  Dim parm(1 To 2) As New DXNVPairDL
  parm(1).Set DX_DL_PARM_QUERY, PQuery
  parm(2).setName DX_DL_PARM_END
  
  'Execute the query
  CQuery.execute parm
  On Error GoTo HandleError
  
  'Process the result
  Dim result As DXResultsDL
  Set result = CQuery.result
  On Error GoTo HandleError
  Dim res As New CombinedQOptResults
  res.ProcessResults result
  res.Show
  Exit Sub
  
HandleError:
  'Handle any errors
  Status.Text = Str(Err.Number) & Err.Description
  
End Sub

