' @copyright(disclaimer) 
' Licensed Materials - Property of IBM
' IBM  Enterprise Information Portal for Multiplatforms V8.1  (program number 5724-B43)
' (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
' 
' US Government Users Restricted Rights
' Use, duplication or disclosure restricted by GSA ADP Schedule
' Contract with IBM Corp.
' 
' DISCLAIMER OF WARRANTIES :
' 
' Permission is granted to copy and modify this Sample code, and to
' distribute modified versions provided that both the copyright
' notice,- and this permission notice and warranty disclaimer appear in all copies and 
' modified versions. 
' 
' THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
' IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, 
' IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE IMPLIED 
' WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL 
' IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF THE USE OF OR 
' INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION OF THE 
' SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS LICENSORS AND 
' SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR DIRECT, INDIRECT, 
' SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF 
' THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
' OF THE POSSIBILITY OF SUCH DAMAGES.
'
' @endCopyright

VERSION 5.00
Begin VB.Form ac 
   Caption         =   "Form1"
   ClientHeight    =   5700
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7575
   LinkTopic       =   "Form1"
   ScaleHeight     =   5700
   ScaleWidth      =   7575
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton btnGetSetItemACL 
      Caption         =   "Get/Set Item ACL"
      Height          =   615
      Left            =   4200
      TabIndex        =   2
      Top             =   4680
      Width           =   3135
   End
   Begin VB.CommandButton btnListACL 
      Cancel          =   -1  'True
      Caption         =   "List ACL"
      Height          =   615
      Left            =   120
      TabIndex        =   1
      Top             =   4680
      Width           =   3495
   End
   Begin VB.TextBox CurrBox 
      Height          =   4095
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   120
      Width           =   7215
   End
End
Attribute VB_Name = "ac"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Sample Program
Dim dsDL As DXDatastoreDL
Dim acDL As DXAccessControlDL
Private Sub cout(s As String)
  CurrBox.Text = CurrBox.Text & s & Chr$(13) & Chr$(10)
  CurrBox.Refresh
End Sub
Private Sub enable_all_buttons(f As Boolean)
  btnListACL.Enabled = f
  btnGetSetItemACL.Enabled = f
End Sub
Private Sub Form_Load()
  Set dsDL = New DXDatastoreDL
  Set acDL = New DXAccessControlDL
  acDL.init dsDL

  cout "Datastore DL created"
  cout "connecting to datastore"
  dsDL.Connect "lsmufasa", "frnadmin", "password"
  cout "datastore connected"
End Sub
Private Sub form_unload(cancel As Integer)
  dsDL.disconnect
  cout "datastore disconnected"
End Sub

Private Sub btnGetSetItemACL_Click()
  enable_all_buttons False
  If acDL.isAccessControlList("demo3") Then
     cout "demo3 is an access control list."
     cout "ACL for D5$H$H36OBHKI19M before change = " & acDL.getItemACL("D5$H$H36OBHKI19M")
     acDL.setItemACL "D5$H$H36OBHKI19M", "demo3"
     cout "ACL for D5$H$H36OBHKI19M after change = " & acDL.getItemACL("D5$H$H36OBHKI19M")
  Else
     cout "demo3 is not an access control list."
  End If
  enable_all_buttons True
End Sub

Private Sub btnListACL_Click()
  enable_all_buttons False
  Dim aclColl As DXSequentialCollectionDL
  Dim aclIter As DXSequentialIteratorDL
  Dim dataColl As DXSequentialCollectionDL
  Dim dataIter As DXSequentialIteratorDL
  Set aclColl = acDL.listAccessControlLists
  Set aclIter = aclColl.createIterator
  
  Dim acl As DXAccessControlListDL
  Dim data As DXAccessDataDL
    
  Dim disp1 As String
  Dim disp2 As String
  Dim disp3 As String
  Dim disp4 As String
  
  Do While aclIter.more
     Set acl = aclIter.Next()
     cout "ACL Name=" + acl.getName() & " Description=" + acl.getDescription()
     Set dataColl = acl.getAccessData()
     Set dataIter = dataColl.createIterator()
     Do While dataIter.more()
        Set data = dataIter.Next()
        disp1 = data.getCommand
        disp2 = data.getPatronType
        disp3 = data.getPatron
        disp4 = data.getPrivilegeName
        cout "    Command=" & disp1 & " Type=" + disp2 & " Patron= " + disp3 & " Privilege= " + disp4
        cout "    ------------------------------"
     Loop
  Loop
  
  enable_all_buttons True
End Sub
