' @copyright(disclaimer) 
' Licensed Materials - Property of IBM
' IBM  Enterprise Information Portal for Multiplatforms V8.1  (program number 5724-B43)
' (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.
' 
' US Government Users Restricted Rights
' Use, duplication or disclosure restricted by GSA ADP Schedule
' Contract with IBM Corp.
' 
' DISCLAIMER OF WARRANTIES :
' 
' Permission is granted to copy and modify this Sample code, and to
' distribute modified versions provided that both the copyright
' notice,- and this permission notice and warranty disclaimer appear in all copies and 
' modified versions. 
' 
' THIS SAMPLE CODE IS LICENSED TO YOU AS-IS. 
' IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, 
' IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE IMPLIED 
' WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO EVENT WILL 
' IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT OF THE USE OF OR 
' INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE, OR COMBINATION OF THE 
' SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS LICENSORS AND 
' SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR FOR DIRECT, INDIRECT, 
' SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF 
' THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS LICENSORS OR SUPPLIERS HAVE BEEN ADVISED 
' OF THE POSSIBILITY OF SUCH DAMAGES.
'
' @endCopyright

VERSION 5.00
Begin VB.Form ProcessRes 
   Caption         =   "Form2"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form2"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox ResultTable 
      Height          =   3255
      Left            =   0
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   0
      Width           =   4695
   End
End
Attribute VB_Name = "ProcessRes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Public Sub ProcessResults(result As DXResultsFed)
  Dim cnt As Integer
  cnt = 0
  
  ' First retrieve the documents/folders from the results collection
  Dim ddo As DXDDOFed
  Dim cursor As DXResultsIteratorFed
  Set cursor = result.createIterator
  Do While cursor.more
    Set ddo = cursor.Next
    'ddo.retrieve
    cnt = cnt + 1
    'Display the data
    If Not (ddo Is Nothing) Then
     DisplayDDO ddo, cnt
    End If
  Loop                             ' end do while cursor.more
End Sub

Public Sub DisplayDDO(ddo As DXDDOFed, cnt As Integer)

  Dim itemType As Integer, count As Integer, i As Integer
  Dim pid As DXPidFed
  Dim strPidString As String
  Dim dataName As String
  Dim data As Variant
  Dim dataObj As Object
  Dim aVar As Variant
  Dim dkXDO As DXXDOFed
  Dim pidXDO As DXPidXDOFed
  aVar = ddo.getPropertyByName(DX_FED_PROPERTY_ITEM_TYPE)
  itemType = aVar
  ResultTable.Text = ResultTable.Text & "=====> Item " & cnt & "<=====" & vbCrLf
  Set pid = ddo.getPidObject
  strPidString = pid.pidString
  ResultTable.Text = ResultTable.Text & "pid " & strPidString & vbCrLf
  ResultTable.Text = ResultTable.Text & "********************" & vbCrLf
  Select Case itemType
    Case DX_FED_DOCUMENT
      ResultTable.Text = ResultTable.Text & "Item is a document" & vbCrLf
      count = ddo.dataCount
      For i = 1 To count
        dataName = ddo.getDataName(i)
        If dataName = DX_FED_DKPARTS Then
          If Not (ddo.IsNull(i)) Then
           Set dataObj = ddo.GetData(i)
           ProcessParts dataObj
          End If
        Else
         aVar = ddo.getDataPropertyById(i, DX_FED_PROPERTY_TYPE)
         propType = aVar
         If propType = DX_FED_DATAITEM_TYPE_XDOOBJECT Then
          If Not (ddo.IsNull(i)) Then
           Set dataObj = ddo.GetData(i)
           If TypeOf dataObj Is DXXDOFed Then
             'Do something with the blob
             Set dkXDO = dataObj
             Set pidXDO = dataObj.getPidObject()
             ResultTable.Text = ResultTable.Text & "Blob found - pid value " & pidXDO.pidString & vbCrLf
           End If
          End If
         Else
          data = ddo.GetData(i)
          If VarType(data) = vbString Or VarType(data) = vbInteger Or _
             VarType(data) = vbLong Or VarType(data) = vbShort Then
            ResultTable.Text = ResultTable.Text & "attribute name: " & dataName & vbCrLf
            ResultTable.Text = ResultTable.Text & "value: " & data & vbCrLf
          End If
         End If
        End If
      Next                         ' end for i = 1 to count
    Case DX_FED_FOLDER
      ResultTable.Text = ResultTable.Text & "Item is a folder" & vbCrLf
      count = ddo.dataCount
      For i = 1 To count
        dataName = ddo.getDataName(i)
        If dataName = DX_FED_DKFOLDER Then
         If Not (ddo.IsNull(i)) Then
          Set dataObj = ddo.GetData(i)
          ProcessFolder dataObj
         End If
        Else
          data = ddo.GetData(i)
          If VarType(data) = vbString Or VarType(data) = vbInteger Or _
             VarType(data) = vbLong Or VarType(data) = vbShort Then
            ResultTable.Text = ResultTable.Text & "attribute name: " & dataName & vbCrLf
            ResultTable.Text = ResultTable.Text & "value: " & data & vbCrLf
          End If
        End If
      Next                         ' end for i = 1 to count
  End Select
  
End Sub

Public Sub ProcessParts(parts As DXPartsFed)

  ResultTable.Text = ResultTable.Text & "This document has " & parts.cardinality & " parts" & vbCrLf
  Dim dataObjCursor As DXSequentialIteratorFed
  Set dataObjCursor = parts.createIterator
  Dim pidXDO As DXPidXDOFed
  Dim j As Integer
  j = 0
  Dim dkObj As Object
  Dim dkXDO As DXXDOFed
    
  Do While dataObjCursor.more
    j = j + 1
    ResultTable.Text = ResultTable.Text & "--------------------" & vbCrLf
    Set dkObj = dataObjCursor.Next
    If TypeOf dkObj Is DXXDOFed Then
      'Do something with the blob
      Set dkXDO = dkObj
      Set pidXDO = dkObj.getPidObject()
      ResultTable.Text = ResultTable.Text & "Blob found - pid value " & pidXDO.pidString & vbCrLf
    Else
      ResultTable.Text = ResultTable.Text & "Unknown type of object!" & vbCrLf
    End If
  Loop                   ' end do while dataObjCursor.more
  
End Sub

Public Sub ProcessFolder(folder As DXFolderFed)

  Dim cnt As Integer
  cnt = 0

  ' First retrieve the documents/folders from the results collection
  Dim ddo As DXDDOFed
  Dim cursor As DXSequentialIteratorFed
  Set cursor = folder.createIterator
  
  Do While cursor.more
    Set ddo = cursor.Next
    ddo.retrieve
    cnt = cnt + 1
    DisplayDDO ddo, cnt
  Loop                             ' end do while cursor.more
  
End Sub


