//
/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
//


// sample connect/execute/disconnect to DES
/*
 * Filename       : TRetrieveXDODES.cpp
 * Description    : Connect to DES Datastore.
 *                  test DKBlobDES.retrieve(String fileName)
 *                  Disconnect from DES Datastore.
 */

#include <iostream.h>
#include <stdio.h>                
#include <DKConstant.h>
#include <DKDatastoreDES.hpp>
#include <DKException.hpp>
#include <DKString.hpp>
#include <dkResultSetCursor.hpp>
#include <DKDDO.hpp>
#include <DKAny.hpp>
#include <DKPid.hpp>
#include <dkCollection.hpp>
#include <DKBlobDES.hpp>
#include <DKPidXDODES.hpp>
#include <DKEnvironment.hpp>

void main(int argc, char *argv[])
{
    cout << "begin..." << endl;

    // Indicate this is a Console Application on Windows NT/95 for error
    // message code page conversion to OEM code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_SS_WINDOWS is the default.
    DKEnvironment::setSubSystem(DK_SS_CONSOLE);

    //-------------------------------------------------------------- 
    // Checking for input parameters
    //--------------------------------------------------------------   
    if (argc < 5)
    {
     cout<<"Usage: "<<endl;
     cout<< argv[0] << "  <libsrv> <userid> <pw> <PORT=80;DESAPPID=appid;DESAPPPW=apppass[;DESCFGPATH=<des cfg file>;DESLOCALE=<locale>;]>" << endl;
     return;
    }
    // ### get input parameters
    DKString libsrv = DKString(argv[1]);
    DKString userid = DKString(argv[2]);
    DKString pw = DKString(argv[3]);
	DKString str = argv[4];

    DKDatastoreDES dsDES;

    try 
	{
	    cout << "Datastore DES created" << endl;
		cout << "connecting to datastore" << endl;
	        dsDES.connect(libsrv,userid,pw,str);
		cout << "datastore connected " << libsrv << " userid - " << userid << endl;

		cout << "executing retrieve a XDO" << endl;

		DKBlobDES* p = new DKBlobDES(&dsDES);
		DKPidXDODES pid;
		pid.setDocId("C:\\ExtendedSearch40\\docs\\readme.txt");
		pid.setDatabaseName("ES Documentation");
		pid.setFieldName("Doc$Content");
		pid.setPrimaryId("ES Documentation|C:\\ExtendedSearch40\\docs\\readme.txt");
		p->setPidObject((DKPidXDO*)&pid);

		p->retrieve("ES-readme.txt");

                delete p;

		cout << "retrieve executed" << endl;

		dsDES.disconnect();
		cout << "disconnect from the DES datastore fine." << endl;
		return;
	}
	catch (DKException& exc)
	{
		cout << "Failed to connect to the DES datastore." << endl;
		cout << "Error id " << exc.errorId() << endl;
		cout << "Exception id " << exc.exceptionId() << endl;
		for(unsigned long i = 0; i< exc.textCount();i++)
		{
			cout << "Error text: " << exc.text(i) << endl;
		}
		for (unsigned long g=0; g< exc.locationCount();g++)
		{
			const DKExceptionLocation* p = exc.locationAtIndex(g);
			cout << "Filename: " << p->fileName() << endl;
			cout << "Function: " << p->functionName() << endl;
			cout << "LineNumber: " << p->lineNumber() << endl;
		}
		cout << "Exception Class Name: " << exc.name() << endl;

		return;
	}
}

