/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/
// sample connect/disconnect to DOMINO.DOC SERVER

/*
 * Filename       : TConnectDD.java
 * Description    : test DKDatastoreDD for connect and disconnect
 *
 */

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.server.*;
import java.io.*;

// TConnectDD class
public class TConnectDD implements DKConstantDD{

  public static String Me = new String("TConnectDD");

  // Main method
  public static void main(String argv[])
  {

    System.out.println(" ");
    //*** for input parameters
    String libURL = new String(""),   // library server
    userid = new String(""),     //userid
    pw = new String(""); // pw

    // Indicate this is a Console Application on Windows NT/95 for error
    // message display in dos console code page. If this was a Windows
    // GUI (Graphic User Interface) Application this would not be necessary
    // because DK_CM_SS_WINDOWS is the default.
    DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

    //--------------------------------------------------------------
    // Checking for input parameters
    //--------------------------------------------------------------

    if (argv.length < 3)
    {
      System.out.println(Me + " Usage: " );
      System.out.println("  java TConnectDD " +
      "<libURL> <userid> <pw>" );
      return;
    }
    else
    {
      libURL = argv[0];
      userid = argv[1];
      pw = argv[2];
      System.out.println(Me + ": Received input parameters...");
      System.out.println("   Parameter1=" + libURL );
      System.out.println("   Parameter2=" + userid );
      System.out.println("   Parameter3=" + pw );
    }
    DKDatastoreDD dsDD = null;
    try
    {
      dsDD = new DKDatastoreDD();

      String userName = dsDD.userName();
      String dsName = dsDD.datastoreName();


      for (int i = 0; i < 2; i++ )
      {
        dsDD.connect(libURL,userid,pw,"");
        System.out.println(Me + ": After connect, isConnected = " + dsDD.isConnected()
          + "\n    datastore name = " + dsDD.datastoreName()
          + "\n    user name      = "  + dsDD.userName());
        dsDD.disconnect();

        System.out.println(Me + ": After disconnect, isConnected = " + dsDD.isConnected()
          + "\n    datastore name = " + dsDD.datastoreName()
          + "\n    user name      = "  + dsDD.userName());
      }
      dsDD.destroy();
    }
    catch (DKException exc)
    {
     try {
     dsDD.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }
     System.out.println(Me + ": DKException message " + exc.getMessage());
     exc.printStackTrace();
    }
    catch (Exception exc)
    {
     try {
     dsDD.destroy();
     }
     catch (Exception e)
     {
      e.printStackTrace();
     }
     System.out.println(Me + ": Exception message " + exc.getMessage());
     exc.printStackTrace();
    }

  }
}

