/*BEGINPROLOGUE************************************************************************
 * @copyright(disclaimer)                                                             *
 * Licensed Materials - Property of IBM                                               *
 * IBM Enterprise Information Portal for Multiplatforms V8.1 (program number 5724-B43)*
 * (c ) Copyright IBM Corp. 1998,  2002. All Rights Reserved.                         *
 *                                                                                    *
 * US Government Users Restricted Rights                                              *
 * Use, duplication or disclosure restricted by GSA ADP Schedule                      *
 * Contract with IBM Corp.                                                            *
 *                                                                                    *
 * DISCLAIMER OF WARRANTIES :                                                         *
 *                                                                                    *
 * Permission is granted to copy and modify this Sample code, and to                  *
 * distribute modified versions provided that both the copyright                      *
 * notice,- and this permission notice and warranty disclaimer appear in all copies   * 
 * and modified versions.                                                             *
 *                                                                                    *
 * THIS SAMPLE CODE IS LICENSED TO YOU AS-IS.                                         *
 * IBM AND ITS SUPPLIERS AND LICENSORS DISCLAIM ALL WARRANTIES, EITHER EXPRESS OR     *
 * IMPLIED, IN SUCH SAMPLE CODE, INCLUDING THE WARRANTY OF NON-INFRINGEMENT AND THE   *
 * IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. IN NO   *
 * EVENT WILL IBM OR ITS LICENSORS OR SUPPLIERS BE LIABLE FOR ANY DAMAGES ARISING OUT *
 * OF THE USE OF OR INABILITY TO USE THE SAMPLE CODE, DISTRIBUTION OF THE SAMPLE CODE,*
 * OR COMBINATION OF THE SAMPLE CODE WITH ANY OTHER CODE. IN NO EVENT SHALL IBM OR ITS*
 * LICENSORS AND SUPPLIERS BE LIABLE FOR ANY LOST REVENUE, LOST PROFITS OR DATA, OR   *
 * FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL,INCIDENTAL OR PUNITIVE DAMAGES,       *
 * HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY,-, EVEN IF IBM OR ITS     *
 * LICENSORS OR SUPPLIERS HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.       *
 *                                                                                    *
 * @endCopyright                                                                      *
 **************************************************************************************/

// sample to do image query from a QBIC Search datastore

import com.ibm.mm.sdk.common.*;
import com.ibm.mm.sdk.client.*;
import java.io.*;

// TClientSampleIQryQBIC class
public class TClientSampleIQryQBIC implements DKConstantDL {

  // Main method
  public static void main(String argv[]){

      // Indicate this is a Console Application on Windows NT/95 for error
      // message display in dos console code page. If this was a Windows
      // GUI (Graphic User Interface) Application this would not be necessary
      // because DK_CM_SS_WINDOWS is the default.
      DKEnvironment.setSubSystem(DK_CM_SS_CONSOLE);

      //-------------------------------------------------------------- 
      // Checking for input parameters
      //-------------------------------------------------------------- 
      if (argv.length < 3){
         System.out.println("Usage: " );
         System.out.println("  java TClientSampleIQryQBIC <qbicSrv> <userid> <pw>" );
         return;
      }
      
      String qbicSrv = argv[0];
      String userid  = argv[1];
      String pw      = argv[2];
      
      DKDatastoreQBIC dsQBIC = null;
      try {
          dsQBIC = new DKDatastoreQBIC();
          System.out.println("Datastore QBIC created");
          System.out.println("connecting to datastore");
          dsQBIC.connect(qbicSrv,userid,pw,"");
          System.out.println("datastore connected");
          dsQBIC.openCatalog("QBICDB", "QBICCAT");
          System.out.println("Catalog opened ");

   	      dkQuery qbicQry = dsQBIC.createQuery("QbColorFeatureClass color=<255,0,0>", (short)0, null);
    	  qbicQry.execute(null);
          System.out.println("QBIC query done ");
          System.out.println("number of results " + qbicQry.numberOfResults());

    	  Object a;
    	  String strData;
    	  String strDataName;
    	  double rank;
    	  short id;
    	  short j;
    	  DKDDO p;
          int i = 0;

    	  DKResults pResults = (DKResults)qbicQry.result();
          dkIterator pIter = pResults.createIterator();
          while (pIter.more()){
      	      p = (DKDDO)pIter.next();
    	      if (p != null) {
                 i++;
                 System.out.println(" *** Item " + i + " ***");
                 for (j = 1; j <= p.dataCount(); j++) {
           	        a = p.getData(j);
           	        strDataName = p.getDataName(j);
		            System.out.println("Attribute name: " + strDataName);
                    if (a != null)
                        System.out.println("   Attribute Value " + a);    
                    else 
                        System.out.println("   Attribute Value is null ");
	             }
              }
     	  }  
          System.out.println("Total number of items " + i);

          dsQBIC.closeCatalog();
          System.out.println("Catalog closed ");
          dsQBIC.disconnect();
          System.out.println("datastore disconnected");
          dsQBIC.destroy();
      }
      catch(DKException exc){
     	  try {
     	      dsQBIC.destroy();
     	  }
     	  catch (Exception e)
     	  {
     	   e.printStackTrace();
     	  }          
          System.out.println("Exception name " + exc.name());
          System.out.println("Exception message " + exc.getMessage());
          System.out.println("Exception error code " + exc.errorCode());
          System.out.println("Exception error state " + exc.errorState());
          exc.printStackTrace();
      }
      catch (Exception exc){
     	  try {
     	      dsQBIC.destroy();
     	  }
     	  catch (Exception e)
     	  {
     	   e.printStackTrace();
     	  }          
          System.out.println("Exception message " + exc.getMessage());
          exc.printStackTrace();
      }
  }

}

